<script lang="ts">
import Vue from 'vue';
import {
  AosAnimationsMixin,
  JihuLocationMixin,
  LocalizedHrefMixin,
} from '../mixins';
import SlpNavigationHOC from '../components/navigation/navigation-hoc.vue';
import NavBanner from '~/components/navigation/nav-banner.vue';
import SlpFooterHOC from '~/components/navigation/footer-hoc.vue';
import ModalFullPage from '~/components/common/modal-full-page.vue';
import { GEO_LOCATION } from '~/common/constants';
import { generateLayoutMeta } from '~/common/meta';
import { MetaInfo } from 'vue-meta/types/vue-meta';

export default Vue.extend({
  components: {
    SlpFooterHOC,
    SlpNavigationHOC,
    ModalFullPage,
    NavBanner,
  },
  mixins: [LocalizedHrefMixin, AosAnimationsMixin, JihuLocationMixin],
  data() {
    return {
      footer: {},
      contentfulEntryUrl: '',
      showModal: false,
    };
  },
  head(): MetaInfo {
    return generateLayoutMeta(this.$route.path, this.$i18n.locale);
  },
  created() {
    this.$nuxt.$on('contentfulIds', (data) => {
      const { spaceId, entryId } = data;
      if (spaceId !== undefined && entryId !== undefined) {
        this.contentfulEntryUrl = `https://app.contentful.com/spaces/${spaceId}/entries/${entryId}`;
      }
    });
  },
  beforeMount() {
    this.validateIndexFiles();
  },
  mounted() {
    this.shouldShowModal();
  },
  methods: {
    validateIndexFiles() {
      if (this.$route.path.endsWith('index.html')) {
        const queryParams = this.$route.query;
        const oldPath = this.$route.path.replace(/(\W*index\.html\W*)/g, '');
        this.$router.replace({
          path: `${oldPath}/`,
          query: queryParams,
        });
      }
    },
    shouldShowModal() {
      const modalShown = sessionStorage.getItem('modalShown');

      if (!modalShown) {
        const preferredLanguage = navigator.language || navigator.languages[0];
        const isChineseLang = ['zh-CN', 'zh-HK', 'zh-MO'].includes(
          preferredLanguage,
        );
        const isChineseLocation = this.geoIP === GEO_LOCATION.PRC;

        if (isChineseLang || isChineseLocation) {
          this.showModal = true;
          sessionStorage.setItem('modalShown', 'true');
        }
      }
    },
    handleClose() {
      this.showModal = false;
    },
  },
});
</script>

<template>
  <div class="grid-wrapper">
    <ModalFullPage v-if="showModal" @close="handleClose" />
    <SlpNavigationHOC />
    <NavBanner :current-locale="$i18n.locale" class="banner" />
    <section ref="localizedContainer">
      <Nuxt role="main" />
    </section>
    <SlpFooterHOC :contentful-entry-id="contentfulEntryUrl" />
  </div>
</template>

<style lang="scss" scoped>
.grid-wrapper {
  display: grid;
  grid-template-areas:
    'nav'
    'banner'
    'content'
    'footer';
  grid-template-columns: 1fr;

  & > * {
    /* This got added to resolve the banner order mobile sizing, if you see regressions, fix on case by case */
    min-width: 0; /* Allow elements to shrink */
    max-width: 100%; /* Prevent stretching */
  }
}

.banner {
  order: 0;

  @media screen and (min-width: 768px) {
    order: -1;
  }
}
</style>
